MODULE Test;
(* Modul zum Testen des Druckertreibers *)

FROM DruckTreiber IMPORT ConfigPrinter, PrintFormFeed, PrintSteuer,
                         PrintString, PrintString4, PrintChar,
                         SetLQ, PrintLn;

FROM FileName IMPORT filename, ClearFilename, GetDriveAndPath, 
                     SelectFilename, compose;

FROM Application IMPORT Init, Terminate;

FROM AES IMPORT FormAlert;

FROM GEMDOS IMPORT PrnOS;

VAR Mask, Dname : filename;
    Cfgname : ARRAY[0..79] OF CHAR;
    Bstr : ARRAY[0..128] OF CHAR;
    abbruch : BOOLEAN;
    
BEGIN
  Init;
  ClearFilename(Mask);
  ClearFilename(Dname);
  GetDriveAndPath(Mask);
  Mask.ext:="CFG";
  SelectFilename(Mask, Dname, abbruch );
  IF NOT(abbruch) THEN
    compose(Dname, Mask, Cfgname );
    ConfigPrinter(3,Cfgname,"?");
    Bstr:="[1][Drucker streikt!][ nochmal | spter ]";
    WHILE NOT(PrnOS() OR abbruch) DO
      abbruch:=FormAlert(1,Bstr)=2;
    END;
    IF NOT(abbruch) THEN
      PrintSteuer(1FH,-1); (* Horizontal Init. *)
      PrintSteuer(20H,-1); (* Vertikal Init. *)
      
      PrintString4(28H,1AH,-1,-1,"Zeichentabelle:");
      PrintString4(1BH,1,-1,-1," !");
      PrintChar(42C); PrintString("#$%&'()*,-./0123456789:;<=>?");
      PrintLn;
      PrintString("@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_"); PrintLn;
      PrintString("`abcdefghijklmnopqsstuvwxyz{|}~"); PrintLn;
      PrintString(""); PrintLn;
      PrintString("ꫬ"); PrintLn;
      PrintString(""); PrintLn;
      PrintString(""); PrintLn; PrintLn;
      
      PrintString4(28H,1AH,-1,-1,"Schnellschrift: "); PrintLn;
      PrintString4(1BH,6,10,1AH,"Fettdruck, kursiv + unterstrichen");
      PrintString4(7,11,1BH,-1," und wieder normal.");
      PrintString4(1,0EH,-1,-1,"Umridruck");
      PrintString4(0FH,12H,-1,-1," Superscript");
      PrintString4(13H,16H,-1,-1," Subscript");  PrintSteuer(17H,-1);
      PrintLn; PrintLn;
      
      SetLQ(TRUE);
      PrintString4(28H,1AH,-1,-1,"Schnschrift:"); PrintLn;
      PrintString4(1BH,6,10,1AH,"Fettdruck, kursiv + unterstrichen");
      PrintString4(7,11,1BH,-1," und wieder normal.");
      PrintString4(1,0EH,-1,-1,"Umridruck");
      IF abbruch THEN END; (* Dummy-Statement wegen Compilerfehler *)
      PrintString4(15,18,-1,-1," Superscript");
      PrintString4(13H,16H,-1,-1," Subscript");  PrintSteuer(17H,-1);
      PrintLn;
      PrintString("Letzte Schnschriftzeile.");
      
      SetLQ(FALSE);
      PrintLn; PrintSteuer(28H,-1);
      PrintString("Schnellschrift."); PrintLn; 
      PrintString("Was ist los?"); PrintLn; 
      
      PrintFormFeed;
      PrintSteuer(21H,-1); (* Drucker Reset *) 
    END;
  END;
  Terminate;
END Test.
